/**
  example code
  asarray_tstringNX:asarray_tstring &split_keys( const char *line, const char *delims, 
 	                			     bool zero_str, const char *quotations, int escape )
			asarray_tstring &split_keys( const char *line, const char *delims,
						     bool zero_str = false )
                        𕪊L[ɐݒ肷

  			asarray_tstring &split_values( const char *line, const char *delims, 
	                    			       bool zero_str, const char *quotations, int escape )
		    	asarray_tstring &split_values( const char *line, const char *delims,
						       bool zero_str = false )
                        𕪊lɐݒ肷

*/
#include <sli/stdstreamio.h>
#include <sli/asarray_tstring.h>
#include <sli/tarray_tstring.h>
#include <sli/ctindex.h>
#include <sli/digeststreamio.h>
#include <sli/tstring.h>

using namespace sli;

int main( int argc, char *argv[] )
{
    stdstreamio sio;

    const char *line = "'Camellia sasanqua' 'Chrysanthemum morifolium' 'Cyclamen persicum'";
    asarray_tstring my_arr;
    //line̕𕪊my_arr̃L[ɐݒ
    my_arr.split_keys(line, " ", false, "'", 0);
    //L[̐ݒmF
    for ( size_t i=0 ; i < my_arr.length() ; i++ ) {
        const char *key = my_arr.key(i);
        sio.printf("%s ... [%s]\n", key, my_arr.cstr(key));
    }

    sio.printf("******************************************\n");

    const char *val = "'Camellia,pink','Chrysanthemum,yellow','Cyclamen,pink'";
    //val̕𕪊my_arr̒lɐݒ
    my_arr.split_values(val, ",", false, "'", 0);
    //L[ƒl̐ݒmF
    for ( size_t i=0 ; i < my_arr.length() ; i++ ) {
        const char *key = my_arr.key(i);
        sio.printf("%s ... [%s]\n", key, my_arr.cstr(key));
    }

    //t@C̓ǂݍ񂾕ݒ肷
    stdstreamio fin;
    tstring line_buf;
    asarray_tstring academy_awards_asarr;

    //t@C̃I[v
    if (fin.open("r","split_key_value.csv") < 0){
      //G[
    }

    //t@C̓ǂݍ
    if ((line_buf = fin.getline()) == NULL){
      //G[
    }

    //s̉sǂݍނ悤Ȃ̂ŁA폜
    line_buf.strtrim();
    sio.printf("line_buf ... [%s]\n", line_buf.cstr());
    //1sڂ̕𕪊my_arr̃L[ɐݒ
    academy_awards_asarr.split_keys(line_buf.cstr(), ",", false);
    for ( size_t i=0 ; i < academy_awards_asarr.length() ; i++ ) {
        const char *key = academy_awards_asarr.key(i);
        sio.printf("%s ... [%s]\n", key, academy_awards_asarr.cstr(key));
    }

    //ÖׁA
    line_buf.init();
    //̍s̓ǂݍ
    if ((line_buf = fin.getline()) == NULL){
      //G[
    }
    line_buf.strtrim();
    sio.printf("line_buf ... [%s]\n", line_buf.cstr());
    //2sڂ̕𕪊my_arr̒lɐݒ
    academy_awards_asarr.split_values(line_buf.cstr(), ",", false);
    for ( size_t i=0 ; i < academy_awards_asarr.length() ; i++ ) {
        const char *key = academy_awards_asarr.key(i);
        sio.printf("%s ... [%s]\n", key, academy_awards_asarr.cstr(key));
    }

    return 0;
}

