/**
  example code
  asarray_tstringNX:const char *const *cstrarray() const
                        Azz̒l̃|C^z
*/
#include <sli/stdstreamio.h>
#include <sli/asarray_tstring.h>

using namespace sli;

int main( int argc, char *argv[] )
{
    stdstreamio sio;

    asarray_tstring my_asarr;
    my_asarr["MIT"] = "cambridge";
    my_asarr["Princeton"] = "New Jersey";
    my_asarr["Berkeley"] = "California";

    const char *const *my_ptr;
    //my_asarr̒l̃|C^z擾
    my_ptr = my_asarr.cstrarray();
    //|C^z̒lo
    if (my_ptr != NULL){
      for (int i = 0; my_ptr[i] != NULL; i++){
        sio.printf("%d ... [%s]\n", i, my_ptr[i]);
      }
    }

    return 0;
}

