/**
  example code
  mdarray饹: long lvalue( ssize_t idx0, ssize_t idx1 = MDARRAY_INDEF, 
		              ssize_t idx2 = MDARRAY_INDEF ) const
                 long long llvalue( ssize_t idx0, ssize_t idx1 = MDARRAY_INDEF, 
			            ssize_t idx2 = MDARRAY_INDEF ) const
                 longlong longѴǤ
*/
#include <sli/stdstreamio.h>
#include <sli/mdarray.h>

using namespace sli;

int main( int argc, char *argv[] )
{
    stdstreamio sio;
    mdarray my_mdarry(FLOAT_ZT, true);

    sio.printf("start\n");

    my_mdarry.f(0) = 123.556;
    //floatǽ
    sio.printf("my_mdarry f... [%g]\n", my_mdarry.f(0));
    //longǽ ʲڤΤ
    sio.printf("my_mdarry lvalue... [%ld]\n", my_mdarry.lvalue(0));
    //long longǽ ʲڤΤ
    sio.printf("my_mdarry llvalue... [%lld]\n", my_mdarry.llvalue(0));

    //ͼθĤ
    my_mdarry.set_rounding(true);
    //longǽ ʲͼθ
    sio.printf("my_mdarry lvalue... [%ld]\n", my_mdarry.lvalue(0));
    //long longǽ ʲͼθ
    sio.printf("my_mdarry llvalue... [%lld]\n", my_mdarry.llvalue(0));

    sio.printf("end\n");

    return 0;
}
